main() 
{
	ambientPlay("ambient_mp_carentan"); 

	//level thread maps\mp\_tankdrive_gmi::main();
	//level thread maps\mp\_jeepdrive_gmi::main();
	level thread maps\mp\_flak_gmi::main();

	level.centerfall = maps\mp\_cvarDef::main( "scr_centerfall", 1, 0, 1, "int" );
	level.toptime = maps\mp\_cvarDef::main( "scr_toptime", 30, 0, 120, "int" );
	precacheShellshock("fall");

	maps\mp\_load::main(); 
	maps\mp\the_fall2_fx::main();

	rotate_obj = getentarray("fan","targetname");
	if(isdefined(rotate_obj))
	{
		for(b=0;b<rotate_obj.size;b++)
		{
			rotate_obj[b] thread ra_rotate();
		}
	}

	whee = getentarray("whee","targetname");
	if(isdefined(whee))
	{
		for(d = 0 ; d < whee.size ; d ++)
			whee[d] thread say_handler();
	}

	top_trigs = getentarray("fall_top_anticamp", "targetname");
	if(isDefined(top_trigs))
	{
		for(i = 0; i < top_trigs.size; i++)
			top_trigs[i] thread anti_camp();
	}

	porters = getentarray("teleporter", "targetname");
	if(isDefined(porters))
	{
		for(y = 0; y < porters.size; y++)
			porters[y] thread port();
	}

	if(!level.centerfall)
	{
		centerfallclips = getentarray("top_fall", "targetname");
		if(isDefined(centerfallclips))
		{
			//iPrintln("num of centerfallclips = " + centerfallclips.size);
			for(x = 0; x < centerfallclips.size; x++)
			{
				//iPrintln("centerfallclips origin = " + centerfallclips[x].origin);
				centerfallclips[x].origin = centerfallclips[x].origin + (0,0,3000);
				//iPrintln("centerfallclips origin = " + centerfallclips[x].origin);
			}
		}
	}

	game["allies"] = "russian"; 
	game["axis"] = "german"; 

	game["russian_soldiertype"] = "conscript";
	game["russian_soldiervariation"] = "winter";
	game["german_soldiertype"] = "german_waffen";
	game["german_soldiervariation"] = "winter";

	game["attackers"] = "axis"; 
	game["defenders"] = "allies"; 

	game["layoutimage"] = "unknown.jpg";
}

ra_rotate()
{
	if (!isdefined(self.speed) || self.speed == 0)
		self.speed = 8.5;
	if (!isdefined(self.script_noteworthy))
		self.script_noteworthy = "x";

	while(true)
	{
		// rotateYaw(float rot, float time, <float acceleration_time>, <float deceleration_time>);
		if (self.script_noteworthy == "y")
			self rotateYaw(360,self.speed);
		else if (self.script_noteworthy == "x")
			self rotateRoll(360,self.speed);
		else if (self.script_noteworthy == "z")
			self rotatePitch(360,self.speed);
		wait ((self.speed)-0.1); // removes the slight hesitation that waittill("rotatedone"); gives.
	}
}

say_handler(say)
{
	while(1)
	{
		self waittill("trigger",other);

		say = randomint(5);

		switch (say)
		{
			case 0:
				other iprintlnbold("^1DOWN WE GO! ^2WHEE!!");
				break;

			case 1:
				other iprintlnbold("^1OMG! ^2Im Gonna Die!");
				break;

			case 2:
				other iprintlnbold("^1Wish I had wings right now!");
				break;

			default:
				other iprintlnbold("^2ARGHHHHHHH!");
				break;
		}

		if(other istouching(self) && isAlive(other) && other.sessionstate != "spectator")
		{
			wait 0.1;
			other playsound("fall");
			other viewkick(96, other.origin);
			other shellshock("fall", 7);
		}
		wait 1;
	}
}

anti_camp()
{
	wait 1;
	if(level.toptime)
	{
		goto = getent(self.target, "targetname");

		for(;;)
		{
			self waittill("trigger",player);
			player.counter = 0;
			while(player istouching(self) && isAlive(player) && player.sessionstate != "spectator")
			{
				wait 1;
				player.counter++;

				if(player.counter == level.toptime - 10)
					player iPrintlnBold("^2You have 10 seconds before you are moved into the fall");

				if(player.counter >= level.toptime)
				{
					player iPrintlnBold("^2You were moved in to the fall");
					player setorigin(goto.origin);
					wait 5;
				}
			}
			wait 1;
		}
	}
}

port()
{
	while(true)
	{
		self waittill("trigger",other);
		if(other meleebuttonpressed() && other usebuttonpressed() && other attackbuttonpressed())
		{
			entTarget = getent(self.target, "targetname");
			other setorigin(entTarget.origin);
			other setplayerangles(entTarget.angles);
		}
		wait 1;
	}
}